var app = require('express')();
var http = require('http').Server(app);
var io = require('socket.io')(http);
const escpos = require('escpos');
// install escpos-usb adapter module manually
escpos.USB = require('escpos-usb');
//escpos.SerialPort = require('escpos-serialport');
//escpos.Network = require('escpos-network');
//escpos.Win = require('escpos-win');

const options = { encoding: "GB18030" /* default */ }
// encoding is optional

function startTotem() {
    try
    {
      console.log('PROCURANDO IMPRESSORA...');
      console.log('VERIFIQUE SE A IMPRESSORA ESTÁ LIGADA E CONECTADA NO PC.');
      var device = null;
      while(device==null){
        try{
          // Select the adapter based on your printer type
          device  = new escpos.USB();
          //device = new escpos.USB("0x0519", "0x000B"); //vid pid
          //device  = new escpos.Win('LPT1');
          //device  = new escpos.SerialPort('COM3');
          //device = new escpos.Network('192.168.0.31',9100);
        }catch(ignored){}
      }

      console.log('IMPRESSORA ENCONTRADA');
       
      const printer = new escpos.Printer(device, options);
      console.log('IMPRESSORA CONECTADA');

      var port = process.env.PORT || 3001;

      app.get('/', function(req, res){
        res.sendFile(__dirname + '/index.html');
      });

      io.on('connection', function(socket){
        socket.on('flugo print', function(msg){

          try
          {
              console.log('chegou msg: '+msg);
              device.open(function(error){
                printer.text(msg);  
                printer.close();
              //printer.flush(); se for LPT
            });
          }catch(err){
            startTotem();
            return;
          }          
            
        });
      });

      http.listen(port, function(){
        console.log('listening on *:' + port);
      });

    }catch(erro){
      startTotem();
    } 
}

startTotem();